# Learning Resources I've been using for building the database

### Introductory Materials

**1. Lectures by Andy Pavlo**
   - **CMU 15-445 Intro to Database Systems**: [YouTube Playlist](https://www.youtube.com/playlist?list=PLSE8ODhjZXjbohkNBWQs_otTrBTrjyohi) (A Pavlo 2019)
   - **CMU 15-721 Advanced Database Systems**: [YouTube Playlist](https://www.youtube.com/playlist?list=PLSE8ODhjZXjasmrEd2_Yi1deeE360zv5O) (A Pavlo 2020)

**2. Books by Martin Kleppman and Alex Petrov**
   - **Designing Data-Intensive Applications**: [Link to Book](https://dataintensive.net/) (M Kleppmann 2017)
   - **Database Internals**: [Link to Book](https://www.databass.dev) (A Petrov 2019)

### Raft Algorithm

**1. Original Paper and Talks**
   - **In Search of an Understandable Consensus Algorithm**: [Raft Paper](https://raft.github.io/raft.pdf) (D Ongaro, J Ousterhout 2014)
   - **Designing for Understandability: The Raft Consensus Algorithm**: [YouTube Video](https://www.youtube.com/watch?v=vYp4LYbnnW8) (J Ousterhout 2016)

**2. Student Guide**
   - **Students' Guide to Raft**: [Blog Post](https://thesquareplanet.com/blog/students-guide-to-raft/) (J Gjengset 2016)

### Parsing Techniques

**1. Books by Thorsten Ball**
   - **Writing An Interpreter In Go**: [Link to Book](https://interpreterbook.com) (T Ball 2016)
   - **Writing A Compiler In Go**: [Link to Book](https://compilerbook.com) (T Ball 2018)

**2. Blog Post**
   - **Parsing Expressions by Precedence Climbing**: [Blog Post](https://eli.thegreenplace.net/2012/08/02/parsing-expressions-by-precedence-climbing) (E Bendersky 2012)

### Transactions and Consistency

**1. Overviews and Classic Papers**
   - **Consistency Models**: [Jepsen Article](https://jepsen.io/consistency) (Jepsen 2016)
   - **A Critique of ANSI SQL Isolation Levels**: [Research Paper](https://www.microsoft.com/en-us/research/wp-content/uploads/2016/02/tr-95-51.pdf) (H Berenson et al 1995)
   - **Generalized Isolation Level Definitions**: [Research Paper](http://pmg.csail.mit.edu/papers/icde00.pdf) (A Adya, B Liskov, P O'Neil 2000)

**2. Blog Posts on MVCC Implementation**
   - **Implementing Your Own Transactions with MVCC**: [Blog Post](https://levelup.gitconnected.com/implementing-your-own-transactions-with-mvcc-bba11cab8e70) (E Chance 2015)
   - **How Postgres Makes Transactions Atomic**: [Blog Post](https://brandur.org/postgres-atomicity) (B Leach 2017)
